#define WIDTH	10
#define HEIGHT	21

#define NEXT_PIECE_OFFSET_X	277
#define NEXT_PIECE_OFFSET_Y	285

#define ACTION_ROTATE_LEFT	"z"
#define ACTION_ROTATE_RIGHT	"x"
#define ACTION_MOVE_LEFT	"Left"
#define ACTION_MOVE_RIGHT	"Right"
#define ACTION_HARD_DROP	"space"
#define ACTION_SOFT_DROP	"Down"
#define ACTION_HOLD		"c"

typedef enum e_pieces {
	O, I, S, Z, L, J, T, _
} piece;

typedef struct s_pos {
	int x;
	int y;
} pos;


signed char pieces[7][4][8] =
// square block
{0, 0, 1, 0, 1, 1, 0, 1, 
0, 0, 0, 0, 0, 0, 0, 0, 	// not used
0, 0, 0, 0, 0, 0, 0, 0, 	// not used
0, 0, 0, 0, 0, 0, 0, 0, 	// not used

// line block
//0, 0, -1, 0, 1, 0, 2, 0,
//0, 0, 0, 1, 0, -1, 0, -2,
//0, 0, -2, 0, -1, 0, 1, 0,	
//-1, 0, -1, 1, -1, -1, -1, -2,
0, 0, -1, 0, 1, 0, 2, 0,
1, 0, 1, 1, 1, -1, 1, -2,
0, -1, -1, -1, 1, -1, 2, -1,
0, 0, 0, 1, 0, -1, 0, -2,

// S-block
//0, 0, -1, -1, 0, -1, 1, 0, 
//0, 0, 0, 1, 1, 0, 1, -1, 
//0, 0, 0, 0, 0, 0, 0, 0,
//0, 0, 0, 0, 0, 0, 0, 0,
0, 0, -1, 0, 0, 1, 1, 1,
0, 0, 0, 1, 1, 0, 1, -1,
0, 0, 0, -1, -1, -1, 1, 0,
0, 0, -1, 0, -1, 1, 0, -1,

// Z-block
//0, 0, 1, 1, 1, 0, 0, -1, 
//0, 0, -1, 0, 0, -1, 1, -1,
//0, 0, 0, 0, 0, 0, 0, 0, 	// not used
//0, 0, 0, 0, 0, 0, 0, 0, 	// not used
0, 0, 0, 1, -1, 1, 1, 0,
0, 0, 0, -1, 1, 0, 1, 1,
0, 0, -1, 0, 0, -1, -1, -1, // not used
0, 0, -1, 0, -1, -1, 0, 1, // not used


// L-block
//0, 0, -1, 0, 1, 0, 1, 1, 
//0, 0, -1, 1, 0, 1, 0, -1,
//0, 0, -1, 0, -1, -1, 1, 0,
//0, 0, 0, 1, 0, -1, 1, -1, 
0, 0, -1, 0, 1, 0, 1, 1,
0, 0, 0, 1, 0, -1, 1, -1,
0, 0, -1, 0, 1, 0, -1, -1,
0, 0, 0, 1, 0, -1, -1, 1,


// J-block
//0, 0, 0, 1, 0, -1, -1, -1,
//0, 0, -1, 0, 1, 0, 1, -1, 
//0, 0, 0, 1, 0, -1, 1, 1,
//0, 0, -1, 1, -1, 0, 1, 0, 
0, 0, -1, 0, 1, 0, -1, 1,
0, 0, 0, 1, 0, -1, 1, 1,
0, 0, -1, 0, 1, 0, 1, -1,
0, 0, 0, 1, 0, -1, -1, -1,

// T-block
//0, 0, -1, 0, 0, 1, 1, 0, 
//0, 0, -1, 0, 0, 1, 0, -1,
//0, 0, -1, 0, 0, -1, 1, 0,  
//0, 0, 0, 1, 0, -1, 1, 0
0, 0, -1, 0, 1, 0, 0, 1,
0, 0, 1, 0, 0, 1, 0, -1,
0, 0, -1, 0, 1, 0, 0, -1,
0, 0, -1, 0, 0, 1, 0, -1};

unsigned char rotations[7] = {1, 4, 2, 2, 4, 4, 4};
