#include <X11/Xlib.h>
#include <xdo.h>

static Display *d;
static Window inchildwin, *props;
static xdo_t *xdo;

void initXStuff() {
	unsigned long n_items, bytes_after_ret;
	int actual_format;
	Atom atom_type_prop;
	
	d = XOpenDisplay(NULL);
	xdo = xdo_new((char *)d);
	
	XGetWindowProperty(d, DefaultRootWindow(d), XInternAtom(d, "_NET_ACTIVE_WINDOW", True), 0, 1, False, AnyPropertyType, &atom_type_prop, &actual_format, &n_items, &bytes_after_ret, (unsigned char**)&props);
}

void freeXStuff() {
	XFree(props);
	XCloseDisplay(d);
}

void getMousePosition(int *x, int *y) {
	unsigned int mask;
	int rootx, rooty, childx, childy;
	Window inwin;
	
	XQueryPointer(d, props[0], &inwin, &inchildwin, x, y, &childx, &childy, &mask);
}

void getPixelColor(int x, int y, int *r, int *g, int *b) {
	XImage *image;
	XColor color;
	
	image = XGetImage(d, RootWindow(d, DefaultScreen(d)), x, y, 1, 1, AllPlanes, XYPixmap);
	color.pixel = XGetPixel(image, 0, 0);
	XFree(image);
	XQueryColor(d, DefaultColormap(d, DefaultScreen(d)), &color);
	
	*r = color.red/256;
	*g = color.green/256;
	*b = color.blue/256;
	
}

void sendKeyStroke(char *keystroke) {
	xdo_keysequence(xdo, inchildwin, keystroke, 0);
	usleep(10000);
}
